#include "main.h"
extern uint8_t currentTimeBase;

volatile u8 ADCDMAfilled = 0;
extern volatile u16 st_TIM4_IRQHandler;

void setupADC(){
u16 tmp;
  ADC_CommonInitTypeDef ADC_CommonInitStructure;
  ADC_InitTypeDef ADC_InitStructure;

  ADC_DeInit(ADC1);
  ADC_DeInit(ADC2);

  // Configure the ADC clock
  RCC_ADCCLKConfig(RCC_ADC12PLLCLK_Div2);  

  /* ADC Calibration procedure */
  ADC_VoltageRegulatorCmd(ADC1, ENABLE);
  ADC_VoltageRegulatorCmd(ADC2, ENABLE);
	tmp=st_TIM4_IRQHandler;
	while((tmp+2)<st_TIM4_IRQHandler);//   Delay();
		
  ADC_SelectCalibrationMode(ADC1, ADC_CalibrationMode_Single);
  ADC_StartCalibration(ADC1);

  ADC_SelectCalibrationMode(ADC2, ADC_CalibrationMode_Single);
  ADC_StartCalibration(ADC2);

  while(ADC_GetCalibrationStatus(ADC1));

  while(ADC_GetCalibrationStatus(ADC2));

   ADC_CommonStructInit(&ADC_CommonInitStructure);
  // Initialize the ADC_Mode member
//  if (currentTimeBase<12)
//    ADC_CommonInitStructure.ADC_Mode = ADC_Mode_Independent;
//   else
//	  ADC_CommonInitStructure.ADC_Mode = ADC_Mode_Interleave;
   ADC_CommonInitStructure.ADC_Mode = ADC_Mode_RegSimul; 

  // initialize the ADC_Clock member
  if (currentTimeBase<8) {
    ADC_CommonInitStructure.ADC_Clock = ADC_Clock_AsynClkMode;
//    ADC_CommonInitStructure.ADC_DMAAccessMode = ADC_DMAAccessMode_1 ; // ADC_DMAAccessMode_2
	} else {
    ADC_CommonInitStructure.ADC_Clock = ADC_Clock_SynClkModeDiv1;
//    ADC_CommonInitStructure.ADC_DMAAccessMode = ADC_DMAAccessMode_2;//Disabled;
	}
  ADC_CommonInitStructure.ADC_DMAAccessMode = ADC_DMAAccessMode_2;
  ADC_CommonInitStructure.ADC_DMAMode = ADC_DMAMode_OneShot;//ADC_DMAMode_Circular; 
//  if (currentTimeBase>11)
//    ADC_CommonInitStructure.ADC_TwoSamplingDelay = 3;
//	 else
    ADC_CommonInitStructure.ADC_TwoSamplingDelay = 0;
  ADC_CommonInit(ADC1, &ADC_CommonInitStructure);

  ADC_StructInit(&ADC_InitStructure);
//  ADC_AutoDelayCmd(ADC2,DISABLE);
	
  switch(currentTimeBase){
    case 14:  //0.25uS
    case 13:  //0.5uS
    case 12:  //1uS
    case 11:  //2.5uS
    case 10:  //5uS
    case 9:   //10uS
    case 8:   //25uS
      // настройки ADC
      //clock for ADC
      RCC_ADCCLKConfig(RCC_ADC12PLLCLK_Div1);
      ADC_RegularChannelConfig(ADC1, ADC_Channel_4, 1, ADC_SampleTime_2Cycles5);
      ADC_RegularChannelConfig(ADC2, ADC_Channel_3, 1, ADC_SampleTime_2Cycles5);
      ADC_AutoDelayCmd(ADC2,ENABLE);
    break;
    case 7:  //50uS
      // настройки ADC
      //clock for ADC
      RCC_ADCCLKConfig(RCC_ADC12PLLCLK_Div2);
      ADC_RegularChannelConfig(ADC1, ADC_Channel_4, 1, ADC_SampleTime_1Cycles5);
      ADC_RegularChannelConfig(ADC2, ADC_Channel_3, 1, ADC_SampleTime_1Cycles5);
      ADC_AutoDelayCmd(ADC2,ENABLE);
    break;
    case 6:  //100uS
      // настройки ADC
      //clock for ADC
      RCC_ADCCLKConfig(RCC_ADC12PLLCLK_Div4);
      ADC_RegularChannelConfig(ADC1, ADC_Channel_4, 1, ADC_SampleTime_1Cycles5);
      ADC_RegularChannelConfig(ADC2, ADC_Channel_3, 1, ADC_SampleTime_1Cycles5);
    break;
    case 5:  //250uS
      // настройки ADC
      //clock for ADC
      RCC_ADCCLKConfig(RCC_ADC12PLLCLK_Div8);
      ADC_RegularChannelConfig(ADC1, ADC_Channel_4, 1, ADC_SampleTime_1Cycles5);
      ADC_RegularChannelConfig(ADC2, ADC_Channel_3, 1, ADC_SampleTime_1Cycles5);
    break;
    case 4:   //500uS
      // настройки ADC
      //clock for ADC
      RCC_ADCCLKConfig(RCC_ADC12PLLCLK_Div8);
      ADC_RegularChannelConfig(ADC1, ADC_Channel_4, 1, ADC_SampleTime_19Cycles5);
      ADC_RegularChannelConfig(ADC2, ADC_Channel_3, 1, ADC_SampleTime_19Cycles5);
    break;
    case 3:   //1mS
      // настройки ADC
      //clock for ADC
      RCC_ADCCLKConfig(RCC_ADC12PLLCLK_Div16);
      ADC_RegularChannelConfig(ADC1, ADC_Channel_4, 1, ADC_SampleTime_19Cycles5);
      ADC_RegularChannelConfig(ADC2, ADC_Channel_3, 1, ADC_SampleTime_19Cycles5);
    break;
    case 2:  //2.5mS
      // настройки ADC
      //clock for ADC
      RCC_ADCCLKConfig(RCC_ADC12PLLCLK_Div16);
      ADC_RegularChannelConfig(ADC1, ADC_Channel_4, 1, ADC_SampleTime_61Cycles5);
      ADC_RegularChannelConfig(ADC2, ADC_Channel_3, 1, ADC_SampleTime_61Cycles5);
    break;
    case 1: //5mS
      // настройки ADC
      //clock for ADC
      RCC_ADCCLKConfig(RCC_ADC12PLLCLK_Div16);
      ADC_RegularChannelConfig(ADC1, ADC_Channel_4, 1, ADC_SampleTime_181Cycles5);
      ADC_RegularChannelConfig(ADC2, ADC_Channel_3, 1, ADC_SampleTime_181Cycles5);
    break;
    case 0: //10mS
      // настройки ADC
      //clock for ADC
      RCC_ADCCLKConfig(RCC_ADC12PLLCLK_Div6);
      ADC_RegularChannelConfig(ADC1, ADC_Channel_4, 1, ADC_SampleTime_601Cycles5);
      ADC_RegularChannelConfig(ADC2, ADC_Channel_3, 1, ADC_SampleTime_601Cycles5);
    break;
  }

  ADC_InitStructure.ADC_ContinuousConvMode = ADC_ContinuousConvMode_Enable;
//  if (currentTimeBase>10)
//   ADC_InitStructure.ADC_Resolution = ADC_Resolution_6b;
//	  else
   ADC_InitStructure.ADC_Resolution = ADC_Resolution_8b;
  ADC_InitStructure.ADC_ExternalTrigConvEvent = ADC_ExternalTrigConvEvent_0;         
  ADC_InitStructure.ADC_ExternalTrigEventEdge = ADC_ExternalTrigEventEdge_None;
  ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;
  ADC_InitStructure.ADC_OverrunMode = ADC_OverrunMode_Disable;   
  ADC_InitStructure.ADC_AutoInjMode = ADC_AutoInjec_Disable;  
  ADC_InitStructure.ADC_NbrOfRegChannel = 1;
  ADC_Init(ADC1, &ADC_InitStructure);
//  if (currentTimeBase>11)  
   ADC_Init(ADC2, &ADC_InitStructure);

  // Configures the ADC DMA
  ADC_DMAConfig(ADC1, ADC_DMAMode_Circular);
    
  // Enable the ADC DMA
  ADC_DMACmd(ADC1, ENABLE);

  // Enable ADC1
  ADC_Cmd(ADC1, ENABLE);
  // Enable ADC2 if ()
//  if (currentTimeBase>11)  
   ADC_Cmd(ADC2, ENABLE);

  // wait for ADC1 ADRDY
  while(!ADC_GetFlagStatus(ADC1, ADC_FLAG_RDY));

  // wait for ADC2 ADRDY
//  if (currentTimeBase>11)  
   while(!ADC_GetFlagStatus(ADC2, ADC_FLAG_RDY));  

}

void initADC(){
DMA_InitTypeDef DMA_InitStructure;
//NVIC_InitTypeDef NVIC_InitStructure;

  // DMA:
    DMA_Cmd(DMA1_Channel1, DISABLE);
    DMA_DeInit(DMA1_Channel1);
//    if (currentTimeBase<12)
//     {
//      DMA_InitStructure.DMA_PeripheralBaseAddr = (uint32_t)&ADC1->DR;
//      DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte;
////      DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord;
//      DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;
////      DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;
//      DMA_InitStructure.DMA_BufferSize = NUM_SAMPLES;
//     } else
//     {
      DMA_InitStructure.DMA_PeripheralBaseAddr = (uint32_t)&ADC1_2->CDR;
//      DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Word;
//      DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Word;
      DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord;
//      DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;
      DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;
      DMA_InitStructure.DMA_BufferSize = NUM_SAMPLES;
//     }
    DMA_InitStructure.DMA_MemoryBaseAddr = (uint32_t)chCapture;
    DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralSRC;
//    DMA_InitStructure.DMA_BufferSize = NUM_SAMPLES;
    DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
    DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;
//    DMA_InitStructure.DMA_Mode = DMA_Mode_Circular;
    DMA_InitStructure.DMA_Mode = DMA_Mode_Normal;
//    DMA_InitStructure.DMA_Priority = DMA_Priority_High;
    DMA_InitStructure.DMA_Priority = DMA_Priority_Medium;
//    DMA_InitStructure.DMA_Priority = DMA_Priority_Low;
    DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;
    DMA_Init(DMA1_Channel1, &DMA_InitStructure);
    DMA_Cmd(DMA1_Channel1, ENABLE);

    DMA_ITConfig(DMA1_Channel1, DMA_IT_TC, ENABLE);
//    DMA_ITConfig(DMA1_Channel1, DMA_IT_HT, ENABLE);

    // enable DMA IRQ
    NVIC_EnableIRQ(DMA1_Channel1_IRQn);
  
    setupADC();
}

void startADCDMA(void){
//  volatile u32 i;

  ADCDMAfilled = 0;
  DMA_Cmd(DMA1_Channel1, DISABLE);

  ADC_StopConversion(ADC1);

//  if (currentTimeBase<12)  
//    DMA_SetCurrDataCounter(DMA1_Channel1, NUM_SAMPLES);
//	 else
    DMA_SetCurrDataCounter(DMA1_Channel1, NUM_SAMPLES/2);
  DMA_Cmd(DMA1_Channel1, ENABLE);

  ADC_Cmd(ADC1, ENABLE);
//  if (currentTimeBase>11)  
   ADC_Cmd(ADC2, ENABLE);

  ADC_StartConversion(ADC1); //  ADC_SoftwareStartConvCmd(ADC1, ENABLE);
}

//void stopADCDMA(void){
//  DMA_Cmd(DMA1_Channel1, DISABLE);
//  if(DMABufferReady)
//    return;
//  DMABufferReady = 1;
//}

//void DMA1_Channel1_IRQHandler(void) __attribute__ ((section (".ccmram")));
void DMA1_Channel1_IRQHandler(void)
{
//  if(DMA_GetITStatus(DMA1_IT_HT1)){
//    DMA_ClearITPendingBit(DMA1_IT_HT1);
//}

//  if(DMA_GetITStatus(DMA1_IT_TC1)){
    ADCDMAfilled = 1;
    DMA_ClearITPendingBit(DMA1_IT_TC1);
    DMA_Cmd(DMA1_Channel1, DISABLE);//    stopADCDMA();
//  }
}
